#######################
#NewsLetter 1.0 By Mojtaba bolhasani
#email:p30graph3@gmail.com
#website:www.preshiaweb.com
#special thanks to icorex
#######################
<?php

/**
 * Getter the resource value;
 * @var string $resourceName the resource key;
 * @var array $dictionary  dictionary name;
 * @var array $args array with optional parameters for sprintf functions.
 * @return string;
 * @access public
 */
function KT_getResource($resourceName='default', $dictionary='default', $args = array()) {
	if (!isset($GLOBALS['iCoreex']['resources'])) {
		$GLOBALS['iCoreex']['resources'] = array();
	}
	$dictionaryFileName = KT_realpath(dirname(realpath(__FILE__)). '/../../../resources/'). $dictionary .'.res.php';
	$resourceValue = $resourceName;
	
	if (!isset($GLOBALS['iCoreex']['resources'][$dictionary])) {
		@include($dictionaryFileName);
		if (isset($res)) {
			$GLOBALS['iCoreex']['resources'][$dictionary] = $res;
		}
	}

	if (isset($GLOBALS['iCoreex']['resources'][$dictionary][$resourceName])) {
		$resourceValue = $GLOBALS['iCoreex']['resources'][$dictionary][$resourceName];
	} else {
		/*if (trim($resourceName) != "" && trim($resourceName) != "%s") {
			die("<br />Resource '".$resourceName."' not defined in dictionary '".$dictionary."'.<br />");
		}*/
		if (substr($resourceValue,-2) == "_D") {
			$resourceValue = substr($resourceValue,0,-2);
		}
	}

	if (count($args) > 0) {
		array_unshift($args, $resourceValue);
		$resourceValue = call_user_func_array('sprintf', $args);
	}
	return $resourceValue;
}
?>